/*
 *      alarm.c  -- simple Motif alarm apps
 *
 *      Copyright (C) 1998  Marek Blaszkowski(mb@kis.p.lodz.pl).
 *     				
 *				http://www.kis.p.lodz.pl/~mb/alarm
 * 
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      
 *  
 */
#include <Intrinsic.h>
#include <Xm/Xm.h>
#include <Xm/DrawingA.h>
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/CascadeB.h>
#include <Xm/CascadeBG.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/SeparatoG.h>
#include <Xm/MenuShell.h>
#include <Xm/MainW.h>
#include <Xm/ScrollBar.h>
#include <Xm/TextF.h>
#include <Xm/Label.h>
#include <Xm/MessageB.h>
#include <Xm/DialogS.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>


time_t t,t1;
char *date,*txt;
struct tm *tm1;
char str[3];
int min,godz;

#define DELAY 1100
#define timerx 70
#define timery 10

Widget shell, toplevel,form1,inputgodz,inputmin,inputsec,butt;
Widget labelgodz,labelmin,labelsec,sep1,sep2,sep3,labelset;
XtAppContext theApp;
XmString l;
Boolean Alarm;


void focusgodz(Widget w,XtPointer clientdata,XtPointer calldata)
{
XtVaSetValues(inputgodz,XmNcursorPositionVisible,True,NULL);
}

void focusmin(Widget w,XtPointer clientdata,XtPointer calldata)
{
XtVaSetValues(inputmin,XmNcursorPositionVisible,True,NULL);
}

void loosefocusgodz(Widget w,XtPointer clientdata,XtPointer calldata)
{
XtVaSetValues(inputgodz,XmNcursorPositionVisible,False,NULL);
}

void loosefocusmin(Widget w,XtPointer clientdata,XtPointer calldata)
{
XtVaSetValues(inputmin,XmNcursorPositionVisible,False,NULL);
}

void set(Widget w,XtPointer clientdata,XtPointer calldata)
{
Alarm=False;
labelset=XtVaCreateManagedWidget("labelset",xmLabelWidgetClass,form1,
                        XmNx,60,
                        XmNy,30,
						 XtVaTypedArg,
						XmNbackground,XmRString,"grey",5,
						XmNlabelString,
						XmStringCreateSimple("Alarm is set"),
                        NULL);
XtManageChild(labelset);
}


void ok(Widget w,XtPointer clientdata,XtPointer calldata)
{

XtUnmanageChild(labelset);
}

void msg(){
Widget box;
Widget form;

form=XtVaCreateWidget ("Shell1", xmDialogShellWidgetClass,
                            shell,
                            XmNwidth, 100,
                            XmNheight, 40,
							NULL);

box = XtVaCreateWidget("form",
                xmMessageBoxWidgetClass,
                form,
				XmNmessageString,XmStringCreateSimple("Alarm!!!!!!!"),
				XmNmessageAlignment,XmALIGNMENT_CENTER,
                NULL );
XtUnmanageChild(XmMessageBoxGetChild(box,XmDIALOG_HELP_BUTTON));
XtUnmanageChild(XmMessageBoxGetChild(box,XmDIALOG_CANCEL_BUTTON));
XtVaSetValues(box,
                XmNwidth, 600,
                XmNheight, 100,XtVaTypedArg,
				XmNbackground,XmRString,"grey",5,
                NULL );

XtAddCallback(XmMessageBoxGetChild(box,XmDIALOG_OK_BUTTON),
				XmNactivateCallback,ok,NULL);
XtManageChild(box);

}

char *int2str(int val){
char num[10]={'0','1','2','3','4','5','6','7','8','9'};
div_t pod;

pod=div(val,10);
str[0]=num[pod.quot]; 
str[1]=num[pod.rem];
str[2]='\x0';

return str;
}

void tim(Widget w,XtIntervalId id){


t=time(&t1);
tm1=localtime(&t);
XtVaSetValues(labelgodz,XmNlabelString,XmStringCreateSimple(int2str(tm1->tm_hour)),NULL);
XtVaSetValues(labelmin,XmNlabelString,XmStringCreateSimple(int2str(tm1->tm_min)),NULL);
XtVaSetValues(labelsec,XmNlabelString,XmStringCreateSimple(int2str(tm1->tm_sec)),NULL);
XtVaGetValues(inputgodz,XmNvalue,&txt,NULL);
godz=atoi(txt);
XtVaGetValues(inputmin,XmNvalue,&txt,NULL);
min=atoi(txt);
if(!Alarm)
if((godz==tm1->tm_hour)&&(min==tm1->tm_min)){
											Alarm=True;
											msg();
											}

XtAppAddTimeOut(theApp,DELAY,(XtTimerCallbackProc)tim,NULL);

}


int main(int argc, char **argv)
{
Alarm=True;
t=time(&t1);
date=ctime(&t);
tm1=localtime(&t);
shell = XtVaAppInitialize(&theApp, "mainW", NULL, 0,
				 &argc, argv, NULL, NULL);
toplevel = XmCreateMainWindow(shell, "MainWindow",NULL, 0);
XtManageChild(toplevel);

form1 = XtVaCreateManagedWidget("Form1",xmFormWidgetClass,
		toplevel,XmNheight,100,XmNwidth,200,
		 XtVaTypedArg,XmNbackground,XmRString,"grey",5,
		NULL);

labelgodz=XtVaCreateManagedWidget("labelgodz",xmLabelWidgetClass,form1,
                        XmNx,timerx,
                        XmNy,timery,
						 XtVaTypedArg,
						XmNbackground,XmRString,"grey",5,
						XmNlabelString,
						XmStringCreateSimple(int2str(tm1->tm_hour)),
                        NULL);
labelmin=XtVaCreateManagedWidget("labelmin",xmLabelWidgetClass,form1,
                        XmNx,timerx+20,
                        XmNy,timery,
						 XtVaTypedArg,
						XmNbackground,XmRString,"grey",5,
						XmNlabelString,
						XmStringCreateSimple(int2str(tm1->tm_min)),
                        NULL);
labelsec=XtVaCreateManagedWidget("labelsec",xmLabelWidgetClass,form1,
                        XmNx,timerx+40,
                        XmNy,timery,
						 XtVaTypedArg,
						XmNbackground,XmRString,"grey",5,
						XmNlabelString,
						XmStringCreateSimple(int2str(tm1->tm_sec)),
                        NULL);
sep1=XtVaCreateManagedWidget("sep1",xmLabelWidgetClass,form1,
                        XmNx,timerx+13,
                        XmNy,timery-1,
						 XtVaTypedArg,
						XmNbackground,XmRString,"grey",5,
						XmNlabelString,
						XmStringCreateSimple(":"),
                        NULL);
sep2=XtVaCreateManagedWidget("sep2",xmLabelWidgetClass,form1,
                        XmNx,timerx+33,
                        XmNy,timery-1,
						 XtVaTypedArg,
						XmNbackground,XmRString,"grey",5,
						XmNlabelString,
						XmStringCreateSimple(":"),
                        NULL);
sep3=XtVaCreateManagedWidget("sep3",xmLabelWidgetClass,form1,
                        XmNx,45,
                        XmNy,65,
						 XtVaTypedArg,
						XmNbackground,XmRString,"grey",5,
						XmNlabelString,
						XmStringCreateSimple(":"),
                        NULL);
inputgodz=XtVaCreateManagedWidget("inputgodz",xmTextFieldWidgetClass,form1,
                        XmNx,10,
                        XmNy,60,
                        XmNwidth,30,
                        XmNheight,30,
                        XmNmaxLength,2,
						 XtVaTypedArg,
						XmNbackground,XmRString,"grey",5,
						XmNcursorPositionVisible,FALSE,
						XmNvalue,int2str(tm1->tm_hour),
                        NULL);
inputmin=XtVaCreateManagedWidget("inputmin",xmTextFieldWidgetClass,form1,
                        XmNx,60,
                        XmNy,60,
                        XmNwidth,30,
                        XmNheight,30,
                        XmNmaxLength,2,
						 XtVaTypedArg,
						XmNbackground,XmRString,"grey",5,
						XmNcursorPositionVisible,FALSE,
						XmNvalue,int2str(tm1->tm_min),
                        NULL);

butt = XtVaCreateManagedWidget ("Set", xmPushButtonWidgetClass,form1,
                        XmNx,150,
                        XmNy,63,
                        XtVaTypedArg,
				XmNbackground,XmRString,"grey",5,
               			 NULL);
XtRealizeWidget(shell);
XtAddCallback(butt,XmNactivateCallback,set,NULL);
XtAddCallback(inputgodz, XmNfocusCallback,
                (XtCallbackProc) focusgodz, (XtPointer) NULL);
XtAddCallback(inputgodz, XmNlosingFocusCallback,
                (XtCallbackProc) loosefocusgodz, (XtPointer) NULL);
XtAddCallback(inputmin, XmNfocusCallback,
                (XtCallbackProc) focusmin, (XtPointer) NULL);
XtAddCallback(inputmin, XmNlosingFocusCallback,
                (XtCallbackProc) loosefocusmin, (XtPointer) NULL);


XtAppAddTimeOut(theApp,DELAY,(XtTimerCallbackProc)tim,NULL);
if(fork()==0)XtAppMainLoop(theApp);
exit(0);
}
